| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ConnectionInterfaceContactBlockingInterface Class Reference
Client-side proxies » Connection proxies

`#include <TelepathyQt/Connection>`

Inheritance diagram for Tp::Client::ConnectionInterfaceContactBlockingInterface:
[legend]

## Public Slots

QDBusPendingReply | BlockContacts (const Tp::UIntList &contacts, bool reportAbusive, int timeout=-1)
QDBusPendingReply | UnblockContacts (const Tp::UIntList &contacts, int timeout=-1)
QDBusPendingReply< Tp::HandleIdentifierMap > | RequestBlockedContacts (int timeout=-1)

## Signals

void | BlockedContactsChanged (const Tp::HandleIdentifierMap &blockedContacts, const Tp::HandleIdentifierMap &unblockedContacts)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions

| ConnectionInterfaceContactBlockingInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ConnectionInterfaceContactBlockingInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ConnectionInterfaceContactBlockingInterface (Tp::DBusProxy *proxy)
| ConnectionInterfaceContactBlockingInterface (const Tp::Client::ConnectionInterface &mainInterface)
| ConnectionInterfaceContactBlockingInterface (const Tp::Client::ConnectionInterface &mainInterface, QObject *parent)
Tp::PendingVariant * | requestPropertyContactBlockingCapabilities () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const
Public Member Functions inherited from QDBusAbstractInterface
virtual | ~QDBusAbstractInterface ()
bool | isValid () const
QDBusConnection | connection () const
QString | service () const
QString | path () const
QString | interface () const
QDBusError | lastError () const
void | setTimeout (int timeout)
int | timeout () const
QDBusMessage | call (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | call (QDBus::CallMode mode, const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | callWithArgumentList (QDBus::CallMode mode, const QString &method, const QList< QVariant > &args)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *returnMethod, const char *errorMethod)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *slot)
QDBusPendingCall | asyncCall (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusPendingCall | asyncCallWithArgumentList (const QString &method, const QList< QVariant > &args)
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
virtual const QMetaObject * | metaObject () const
QString | objectName () const
void | setObjectName (const QString &name)
bool | isWidgetType () const
bool | signalsBlocked () const
bool | blockSignals (bool block)
QThread * | thread () const
void | moveToThread (QThread *targetThread)
int | startTimer (int interval)
void | killTimer (int id)
T | findChild (const QString &name) const
QList< T > | findChildren (const QString &name) const
QList< T > | findChildren (const QRegExp &regExp) const
QObject * | child (const char *objName, const char *inheritsClass, bool recursiveSearch) const
const QObjectList & | children () const
void | setParent (QObject *parent)
void | installEventFilter (QObject *filterObj)
void | removeEventFilter (QObject *obj)
bool | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const
bool | disconnect (const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *receiver, const char *method)
void | dumpObjectTree ()
void | dumpObjectInfo ()
bool | setProperty (const char *name, const QVariant &value)
QVariant | property (const char *name) const
QList< QByteArray > | dynamicPropertyNames () const
void | destroyed (QObject *obj)
QObject * | parent () const
bool | inherits (const char *className) const
void | deleteLater ()
| QObject (QObject *parent, const char *name)
void | insertChild (QObject *object)
void | removeChild (QObject *object)
bool | isA (const char *className) const
const char * | className () const
const char * | name () const
const char * | name (const char *defaultName) const
void | setName (const char *name)

## Static Public Member Functions

static QLatin1String | staticInterfaceName ()
Static Public Member Functions inherited from QObject
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
bool | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)

## Protected Member Functions

virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const
Protected Member Functions inherited from QObject
QObject * | sender () const
int | senderSignalIndex () const
int | receivers (const char *signal) const
virtual void | timerEvent (QTimerEvent *event)
virtual void | childEvent (QChildEvent *event)
virtual void | customEvent (QEvent *event)
virtual void | connectNotify (const char *signal)
virtual void | disconnectNotify (const char *signal)
bool | checkConnectArgs (const char *signal, const QObject *object, const char *method)

## Additional Inherited Members

Protected Slots inherited from Tp::AbstractInterface
Static Protected Member Functions inherited from QObject
QByteArray | normalizeSignalSlot (const char *signalSlot)
Properties inherited from QObject
| objectName

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Connection.Interface.ContactBlocking".

## Constructor & Destructor Documentation

## § ConnectionInterfaceContactBlockingInterface() [1/5]

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceContactBlockingInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ConnectionInterfaceContactBlockingInterface() [2/5]

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceContactBlockingInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ConnectionInterfaceContactBlockingInterface() [3/5]

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ConnectionInterfaceContactBlockingInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## § ConnectionInterfaceContactBlockingInterface() [4/5]

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface | ) |

explicit

Creates a ConnectionInterfaceContactBlockingInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters

  mainInterface | The proxy to use.

## § ConnectionInterfaceContactBlockingInterface() [5/5]

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ConnectionInterfaceContactBlockingInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

## § staticInterfaceName()

static QLatin1String Tp::Client::ConnectionInterfaceContactBlockingInterface::staticInterfaceName | ( |  | ) |

inline static

Returns the name of the interface "org.freedesktop.Telepathy.Connection.Interface.ContactBlocking", which this class represents.

Returns
  The D-Bus interface name.

## § requestPropertyContactBlockingCapabilities()

Tp::PendingVariant* Tp::Client::ConnectionInterfaceContactBlockingInterface::requestPropertyContactBlockingCapabilities | ( |  | ) | const

inline

Asynchronous getter for the remote object property `ContactBlockingCapabilities` of type `uint`.

Additional capabilities for contact blocking; currently, this is limited to whether contacts may be reported as abusive.

Note that there is no capability for supporting blocking itself: the presence of this interface on a ConnectionInterface indicates that blocking contacts is supported.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestAllProperties()

Tp::PendingVariantMap* Tp::Client::ConnectionInterfaceContactBlockingInterface::requestAllProperties | ( |  | ) | const

inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

## § BlockContacts

QDBusPendingReply Tp::Client::ConnectionInterfaceContactBlockingInterface::BlockContacts | ( | const Tp::UIntList & | contacts,
|  | bool | reportAbusive,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `BlockContacts` on the remote object.

Direct the server to block some contacts. The precise effect is protocol-dependent, but SHOULD include ignoring all current and subsequent communications from the given contacts, avoiding sending presence to them in future, and if they were already receiving the local user's presence, behaving as if the local user went offline.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  contacts

      Some contacts to block. If some of the contacts in this list are
      already blocked, the connection manager MUST act as if they were
      not specified in this list.

  reportAbusive

  In addition to blocking, report these contacts as abusive to the server administrators.

  Clients can determine whether this capability is available by checking the ContactBlockingCapabilities property. If this argument is set to `True` by a client despite ContactBlockingCapabilities not containing the `Can_Report_Abusive` flag, the connection manager SHOULD act as if it were `False` and simply block the supplied contacts.

  A correct user interface shouldn't get this far without knowing that reporting abusive contacts is not supported. If it does, then the user has expressed their intention to block these contacts. Returning an error would leave the UI with three options:
  - Ignore the error, leaving the contacts not actually blocked;
  - Display an error to the user;
  - Call this method again, passing `False` for this argument.

  None of these seem preferable to the CM just ignoring this flag if it doesn't support it: that way, the contacts will be blocked, as the user requested, and UIs have fewer ways to mess up entirely.

  timeout | The timeout in milliseconds.

## § UnblockContacts

QDBusPendingReply Tp::Client::ConnectionInterfaceContactBlockingInterface::UnblockContacts | ( | const Tp::UIntList & | contacts,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `UnblockContacts` on the remote object.

Direct the server to unblock some contacts.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  contacts

      Some contacts to unblock. If some of the contacts in this list are
      not currently blocked, the connection manager MUST act as if they
      were not specified in this list.

  timeout | The timeout in milliseconds.

## § RequestBlockedContacts

QDBusPendingReply<Tp::HandleIdentifierMap> Tp::Client::ConnectionInterfaceContactBlockingInterface::RequestBlockedContacts | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `RequestBlockedContacts` on the remote object.

List the contacts that are blocked.

Clients SHOULD allow a relatively long timeout for calls to this method, since on some protocols contact blocking is part of the contact list, which can take a significant time to retrieve.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

Returns

      The blocked contacts’ handles, together with their identifiers.

## § BlockedContactsChanged

void Tp::Client::ConnectionInterfaceContactBlockingInterface::BlockedContactsChanged | ( | const Tp::HandleIdentifierMap & | blockedContacts,
|  | const Tp::HandleIdentifierMap & | unblockedContacts
| ) |  |

signal

Represents the signal `BlockedContactsChanged` on the remote object.

Emitted when the list of blocked contacts is first retrieved (before returning from any pending calls to RequestBlockedContacts() ), and whenever the list of blocked contacts subsequently changes.

Parameters

  blockedContacts

      Contacts added to the result of RequestBlockedContacts.

  unblockedContacts

      Contacts removed from the result of RequestBlockedContacts.

## § invalidate()

void Tp::Client::ConnectionInterfaceContactBlockingInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |

protected virtual

Reimplemented from Tp::AbstractInterface.